<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>OS Zoomstile BNG Vector Tile Demo</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/ol@v7.4.0/ol.css" />
    <style>
        body { margin:0; padding:0; }
        #map1 { position:absolute; top:0; bottom:0; width:50%; }
	#map2 { position:absolute; top:0; bottom:0; right: 0; width:50%; }
    </style>
</head>
<body>
  <div id="map1"></div>
  <!--<div id="map2"></div>-->
  <div id="info"></div>
<script src="https://cdn.jsdelivr.net/npm/ol@v7.4.0/dist/ol.js"></script>
<script src="https://unpkg.com/ol-mapbox-style@12.2.0/dist/olms.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/proj4js/2.7.0/proj4.js"></script>
<script>

    // Setup the EPSG:27700 (British National Grid) projection.
    proj4.defs("EPSG:27700", "+proj=tmerc +lat_0=49 +lon_0=-2 +k=0.9996012717 +x_0=400000 +y_0=-100000 +ellps=airy +towgs84=446.448,-125.157,542.06,0.15,0.247,0.842,-20.489 +units=m +no_defs");
    ol.proj.proj4.register(proj4);

    // Set the grid pattern options for the vector tile service.
    const extent = [-238375, 0, 900000, 1376256]; // xmin, ymin, xmax, ymax
    const origin = [-238375, 1376256];
    const resolutions = [3584, 1792, 896, 448, 224, 112, 56, 28, 14, 7, 3.5, 1.75, 0.875, 0.4375, 0.21875, 0.109375];
    const tileSize = 512;
    const tileGrid = new ol.tilegrid.TileGrid({ extent, origin, resolutions, tileSize });

    // Setup the geopakcage zoomstack layer
    const zsGpkgLayer = new ol.layer.VectorTile({ maxZoom: 14 });
  
    zsGpkgLayer.setSource(
        new ol.source.VectorTile({
            format: new ol.format.MVT(),
            url: 'http://localhost:9000/data/tiles-combined/{z}/{x}/{y}.pbf',
            projection: 'EPSG:27700',
            tileGrid: tileGrid
        })
    );
  
    olms.applyStyle(zsGpkgLayer, "/outdoor-withland.json", { updateSource: false }, { resolutions: tileGrid.getResolutions() });


    /*
    // Create the zoomstack mbtiles layer
    const zsMbtilesLayer = new ol.layer.VectorTile({
      source: new ol.source.VectorTile({
            format: new ol.format.MVT(),
            url: 'http://localhost:9000/oszs_mbtiles/{z}/{x}/{y}.pbf',
      })
    });
    
    olms.applyStyle(zsMbtilesLayer, "/outdoor.json", { updateSource: false });
    */
  
    // Create a layer around a test area
     const markerStyle = new ol.style.Style({
        stroke: new ol.style.Stroke({ width: 4, color: [0, 255, 0, 1] })
    })
    const x1 = 363737
    const y1 = 168448
    const tilesize = 3584
    const line1 = [[x1, y1],[x1, y1 + tilesize], [x1 + tilesize, y1 + tilesize], [x1 + tilesize, y1], [x1, y1]]
    const markerLine = new ol.Feature({ geometry: new ol.geom.LineString(line1) });
    const markerSource = new ol.source.Vector({ features: [markerLine] });
    const markerLayer = new ol.layer.Vector({ source: markerSource, style: markerStyle, projection: 'EPSG:27700' });
    
    const view = new ol.View({
      projection: 'EPSG:27700',
      extent: [-238375.0, 0.0, 900000.0, 1376256.0],
      resolutions: tileGrid.getResolutions(),
      center: [361009 + 2500, 171796 + 2500], // center of test box
      zoom: 9,
      maxZoom: 14
    });
  
    const map1 = new ol.Map({
    	target: "map1",
         layers: [zsGpkgLayer, markerLayer],
         view: view
     });

    /*
    const map2 = new ol.Map({
      target: "map2",
	layers: [zsMbtilesLayer],
	view: new ol.View({
	  projection: 'EPSG:3857',
          zoom: 13,
          center: [-279450.37606413267,6704017.434385342]
      })
    });
    */
    
</script>
</body>
</html>
